//+------------------------------------------------------------------+
//|                                                        RI_v1.mq4 |
//|                                  Copyright  2007, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_buffers   1
#property indicator_color1    LightBlue
#property indicator_width1    2
#property indicator_level1    20
#property indicator_level2    80

//---- input parameters
extern int       Length     = 10; // Period of evaluation
extern int       Smooth     =  3; // Period of smoothing
extern int       MA_Mode    =  1; // Mode of Moving Average
 
//---- buffers
double RI[];
double rRI[];
double W[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(3);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,RI);
   //SetIndexStyle(1,DRAW_LINE);
   //SetIndexBuffer(1,SigREI);
   SetIndexBuffer(1,rRI);
   SetIndexBuffer(2,W);
//---- name for DataWindow and indicator subwindow label
   string short_name="RI("+Length+","+Smooth+","+MA_Mode+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"RI");
   //SetIndexLabel(1,"Signal");

//----
   SetIndexDrawBegin(0,Length+Smooth);
   //SetIndexDrawBegin(1,Length+Smooth+Signal);
  
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int      shift, limit, counted_bars=IndicatorCounted();
   
//---- 
   if ( counted_bars < 0 ) return(-1);
   if ( counted_bars ==0 ) limit=Bars-Length-Smooth-1;
   if ( counted_bars < 1 ) 
   
   for(int i=1;i<Length+Smooth;i++) 
   {
   RI[Bars-i]=0;    
   rRI[Bars-i]=0;    
   }
     
   if(counted_bars>0) limit=Bars-counted_bars;
   limit--;
   
   for(shift=limit; shift>=0; shift--)
   {
   double Hi = MathMax(High[shift],Close[shift+1]);
   double Lo = MathMin(Low[shift],Close[shift+1]);
   double TR = Hi - Lo; 
    
      if (Close[shift] > Close[shift+1]) 
      W[shift] = TR/(Close[shift] - Close[shift+1]);
      else
      W[shift] = TR;       
      
      double maxW = -1; double minW = 10000000;
      for (i=0; i<=Length-1; i++)
      {
      maxW = MathMax(maxW,W[shift+i]);
      minW = MathMin(minW,W[shift+i]);
      }
      
   if ((maxW - minW)>0) rRI[shift] = 100*(W[shift] - minW)/(maxW - minW);
   }
      
   for( shift=limit; shift>=0; shift--)
   RI[shift] = iMAOnArray(rRI,0,Smooth,0,MA_Mode,shift);     

//----
   return(0);
}
//+------------------------------------------------------------------+